#!/bin/sh
# http://www.mega-nerd.com/libsndfile/
#
# script: til <rob DOT til DOT freedman AT googlemail DOT com>
REPO=http://zenwalk.pinguix.com/user-accounts/tilderb/extra/l/libsndfile
set -e -u -x

#  bzr get http://www.mega-nerd.com/Bzr/libsndfile-dev
#  cd libsndfile-dev/
#  ./autogen.sh && make

#libsndfile
version=1.0.23
build=66.1
arch=i686
# good compromise for nearly everyone doing sound work
# spanning centuries of processor generations
tune=pentium-m
tune=${tune:-pentium-m}

pkgname=libsndfile-$version
package=$pkgname-$arch-$build

PKG_SRC="http://www.mega-nerd.com/libsndfile/libsndfile-$version.tar.gz
$REPO/build-libsndfile.sh"
PKG_DEP="alsa-lib,flac,libogg,libsamplerate,libvorbis"
DOC_URL="http://www.mega-nerd.com/libsndfile/"

# check source exists
#for url in $PKG_SRC;do [ ! -e ${url##*/} ] && wget -N -c $url; done

# tmp tree
CWD=`pwd`
TMP=${TMP:-$CWD/tmp}
PKG=$TMP/$package
SRC=$TMP/$pkgname

# prepare build directory
[ -d $SRC ] && rm -fr $SRC
[ -d $PKG ] && rm -fr $PKG
mkdir -p $SRC $PKG/{install,usr/{src,doc}/$pkgname}

# build directory
tar xzf $CWD/$pkgname.tar.gz --strip-components=1 -C $SRC
#cp -a $CWD/libsndfile-dev/* $SRC
 
cd $SRC
#( set +x; ./autogen.sh )
#
./configure --help >$CWD/configure-help

# fix doc dir
sed -i "s:/share/doc/libsndfile1-dev/html:/doc/$pkgname/html:" configure

CFLAGS="-O2 -march=$arch -mtune=$tune" \
CXXFLAGS="-O2 -march=$arch -mtune=$tune" \
  ./configure \
   --prefix=/usr \
   --mandir=/usr/man \
   --disable-sqlite \
   --disable-octave \
   --disable-static 
make
make -k check &>$CWD/check.log

make install DESTDIR=$PKG
(cd $PKG;find usr -printf "%M %u:%g %p %l\n" >$CWD/installed.files)
# clean up 
# no sqlite - no regtest
rm -fr $PKG/usr/doc/$pkgname/html $PKG/usr/bin/sndfile-regtest

# docs
gzip -9 ChangeLog
cp -a AUTHORS ChangeLog.gz COPYING NEWS README \
    $PKG/usr/doc/$pkgname
echo "$DOC_URL" >$PKG/usr/doc/$pkgname/libsndfile-docs.url

# strip symbols
find $PKG/usr |xargs file |grep "executable\|shared object" |grep ELF |\
	cut -f 1 -d :| xargs -r strip --strip-unneeded
	
#find $PKG/usr/lib |xargs file |grep "current ar archive" |\
#	cut -f 1 -d : |xargs -r strip -g
	
# zip man pages
find $PKG/usr/man -type f -exec gzip -9 {} \;

# create slack description
#         |-----handy-ruler-------------------------------------------------------|
cat <<EOF > $PKG/install/slack-desc
libsndfile: libsndfile (read/write audio files)
libsndfile:
libsndfile: libsndfile is a C library for reading and writing files
libsndfile: containing sampled sound (such as WAV and AIFF format) 
libsndfile: through one standard library interface.s
libsndfile:
libsndfile: It is released under the terms of the GNU Lesser General Public
libsndfile: License, of which there are two versions; version 2.1  and version 3.
libsndfile: 
libsndfile: The user may choose to use libsndfile under either of the above 
libsndfile: two licenses.
EOF

# build script
cp $CWD/build-libsndfile.sh $PKG/usr/src/$pkgname

# create package
cd $PKG
fakeroot /sbin/makepkg -l y -c n $CWD/$package.txz

cd $CWD
echo "$PKG_SRC" >$package.src
echo -n $PKG_DEP >$package.dep
md5sum $package.txz >$package.md5

